package l03_arrays;

import utilities.MatrixHelper;
import utilities.RandomGenerators;

public class MultiDimArray {

	private static void init3D(int[][][] a) {
		for(int i = 0; i < a.length; i++) {
			for(int j = 0; j < a[i].length; j++) {
				for(int k = 0; k < a[i][j].length; k++) {
					a[i][j][k] = RandomGenerators.getInt(100);
				}
			}
		}
	}

	private static void print3D(int[][][] a) {
		System.out.println();
		for(int i = 0; i < a.length; i++) {
			System.out.println("a[" + i + "]");
			MatrixHelper.printMatrix(a[i]);
		}
		System.out.println();
	}

	public static void main(String[] args) {

// 3-D array with fixed length:
		int[][][] a2 = new int[2][2][4];
		init3D(a2);
		print3D(a2);
		System.out.println("-----------------------------------------");

// 3-D array with varied-length vectors:
		int[][][] a3 = new int[RandomGenerators.getInt(2, 7)][][];
		for(int i = 0; i < a3.length; i++) {
			a3[i] = new int[RandomGenerators.getInt(2, 5)][];
			for(int j = 0; j < a3[i].length; j++) {
				a3[i][j] = new int[RandomGenerators.getInt(2, 5)];
			}
		}
		init3D(a3);
		print3D(a3);
	}
}

